import abc
from . import utils as utils
from .exceptions import FilestorageConfigError as FilestorageConfigError
from .file_item import FileItem as FileItem
from abc import ABC
from typing import Awaitable, Optional

class FilterBase(ABC, metaclass=abc.ABCMeta):
    async_ok: bool = ...
    def validate(self) -> Optional[Awaitable]: ...
    def call(self, item: FileItem) -> FileItem: ...
    async def async_call(self, item: FileItem) -> FileItem: ...

class AsyncFilterBase(FilterBase, ABC, metaclass=abc.ABCMeta):
    async_ok: bool = ...
